From ddbc205ba1704675024ad2503d01f5d8c7c4205e Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:08 +0000
Subject: [PATCH 950/1001] Make auth testing closer to real auth


---

diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 15051a6..fddf404 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -141,7 +141,7 @@ def auth_set(APP, auth):
             g.auth = munch.Munch(logged_in=False)
             g.user = None
         else:
-            g.user = auth.user
+            g.user = FakeUser(auth.nickname)
 
     if flask._app_ctx_stack.top is None:
         # App context isn't pushed yet
@@ -162,25 +162,19 @@ class FakeUser(object):
             supposed to be.
         """
         self.username = username
-        self.booksmarks = []
+        self.bookmarks = []
         self.groups = []
 
 
-class FakeAuthorization(object):
+def FakeAuthorization(username):
     """ Fake Authorization used to set as flask.g.auth. """
-
-    def __init__(self, username='username'):
-        """ Constructor.
-        :arg groups: list of the groups in which this fake user is
-            supposed to be.
-        """
-        self.logged_in = True
-        self.fullname = 'fullname: ' + username
-        self.email = 'email: ' + username
-        self.user = FakeUser(username)
-        self.avatar = 'avatar_src_url'
-        self.nickname = username
-        self.username = username
+    return munch.Munch(
+        logged_in=True,
+        fullname='fullname: ' + username,
+        nickname=username,
+        email='email: ' + username,
+        avatar='avatar_src_url',
+    )
 
 
 @contextmanager
diff --git a/hubs/tests/test_authz.py b/hubs/tests/test_authz.py
index 7a7c85a..f47b85f 100644
--- a/hubs/tests/test_authz.py
+++ b/hubs/tests/test_authz.py
@@ -2,7 +2,7 @@ from __future__ import absolute_import, unicode_literals
 
 from hubs.app import app
 from hubs.authz import ObjectAuthzMixin, AccessLevel, PERMISSIONS
-from hubs.tests import APPTest, FakeAuthorization
+from hubs.tests import APPTest, FakeUser
 
 
 class TestObj(ObjectAuthzMixin):
@@ -35,25 +35,25 @@ class AuthzTestCase(APPTest):
 
     def test_mixin_access_level_logged_in(self):
         obj = TestObj()
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         self.assertEqual(
             obj._get_auth_access_level(user), AccessLevel.logged_in)
 
     def test_mixin_group_access_level(self):
         obj = TestObj(roles={"auth-group": "member"})
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         self.assertEqual(
             obj._get_auth_access_level(user), AccessLevel.member)
 
     def test_mixin_group_access_level_no_role(self):
         obj = TestObj(roles={"unrelated-group": "member"})
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         self.assertEqual(
             obj._get_auth_access_level(user), AccessLevel.logged_in)
 
     def test_mixin_group_access_level_unsupported(self):
         obj = TestObj(roles={"auth-group": "dark_lord"})
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         self.assertEqual(
             obj._get_auth_access_level(user), AccessLevel.logged_in)
 
@@ -68,7 +68,7 @@ class AuthzTestCase(APPTest):
         self.assertFalse(obj.allows(None, 'widget.restricted.view'))
 
     def test_allows_logged_in(self):
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         obj = TestObj()
         self.assertTrue(obj.allows(user, 'hub.public.view'))
         self.assertTrue(obj.allows(user, 'hub.preview.view'))
@@ -79,7 +79,7 @@ class AuthzTestCase(APPTest):
         self.assertTrue(obj.allows(user, 'widget.restricted.view'))
 
     def test_allows_member(self):
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         obj = TestObj(roles={"auth-group": "member"})
         self.assertTrue(obj.allows(user, 'hub.public.view'))
         self.assertTrue(obj.allows(user, 'hub.preview.view'))
@@ -90,7 +90,7 @@ class AuthzTestCase(APPTest):
         self.assertTrue(obj.allows(user, 'widget.restricted.view'))
 
     def test_allows_sponsor(self):
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         obj = TestObj(roles={"auth-group": "sponsor"})
         self.assertTrue(obj.allows(user, 'hub.public.view'))
         self.assertTrue(obj.allows(user, 'hub.preview.view'))
@@ -101,7 +101,7 @@ class AuthzTestCase(APPTest):
         self.assertTrue(obj.allows(user, 'widget.restricted.view'))
 
     def test_allows_owner(self):
-        user = FakeAuthorization('ralph')
+        user = FakeUser('ralph')
         obj = TestObj(roles={"auth-group": "owner"})
         self.assertTrue(obj.allows(user, 'hub.public.view'))
         self.assertTrue(obj.allows(user, 'hub.preview.view'))
@@ -112,7 +112,7 @@ class AuthzTestCase(APPTest):
         self.assertTrue(obj.allows(user, 'widget.restricted.view'))
 
     def test_allows_site_admin(self):
-        user = FakeAuthorization('admin')
+        user = FakeUser('admin')
         obj = TestObj()
         for perm in PERMISSIONS.keys():
             self.assertTrue(obj.allows(user, perm))
diff --git a/hubs/tests/views/test_user.py b/hubs/tests/views/test_user.py
index 127fd36..eb1ed6a 100644
--- a/hubs/tests/views/test_user.py
+++ b/hubs/tests/views/test_user.py
@@ -50,7 +50,7 @@ class TestGetNotifications(hubs.tests.APPTest):
     def test_get_notifications_valid_name(self):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.get('/stream/saved/'.format(
-                self.user.username))
+                self.user.nickname))
 
         self.assertEqual(resp.status_code, 200)
         data = json.loads(resp.get_data(as_text=True))
@@ -63,7 +63,7 @@ class TestGetNotifications(hubs.tests.APPTest):
 class TestPostNotifications(hubs.tests.APPTest):
     user = hubs.tests.FakeAuthorization('ralph')
     valid_payload = {
-        'username': user.username,
+        'username': user.nickname,
         'markup': 'foobar',
         'link': 'baz',
         'secondary_icon': 'http://placekitten.com/g/200/300',
@@ -71,7 +71,7 @@ class TestPostNotifications(hubs.tests.APPTest):
     }
 
     invalid_payload = {
-        'username': user.username,
+        'username': user.nickname,
     }
 
     def test_post_notification_invalid_payload(self):
@@ -99,7 +99,7 @@ class TestPostNotifications(hubs.tests.APPTest):
         self.assertEqual(notification['link'], 'baz')
 
         all_saved = hubs.models.SavedNotification.by_username(
-            self.user.username)
+            self.user.nickname)
         self.assertEqual(len(all_saved), 2)
         all_saved = [s.__json__() for s in all_saved]
         self.assertTrue(any(str(s['markup']) == self.valid_payload['markup']
@@ -140,7 +140,7 @@ class TestDeleteNotifications(hubs.tests.APPTest):
 
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.delete(
-                '/stream/saved/{}/'.format(self.user.username, idx)
+                '/stream/saved/{}/'.format(self.user.nickname, idx)
             )
         self.assertEqual(resp.status_code, 404)
 

